
{ CDROM Software aus c't 2.1993 Peter Siering / erweitert 10.1993 J.Wendel }
{                                                                          }
PROGRAM CD_ROM_Drive_Info;
USES
    Dos, Crt;
CONST
     Ja          = 'Ja';
     Nein        = 'Nein';
     MaxFeatures = 12;

     Features: ARRAY [0..12, 1..3] OF STRING =
       (( 'Tr', 'geschlossen', 'offen'),
        ( 'Tr', 'verriegelt','unverriegelt'),
        ( 'Support fr', 'cooked', 'cooked und raw'),
        ( '', 'Nur Lesen', 'Lesen und Schreiben'),
        ( '', 'Nur Daten', 'Daten, Audio und Video'),
        ( '', 'Kein Interleave', 'IS0-9660'),
        ( 'Reserviert', '', ''),
        ( 'Command-Prefetching ', Nein, Ja),
        ( 'Audio-Manipulation  ', Nein, Ja),
        ( 'Adressierung        ', 'HSG', 'HSG und Red Book'),
        ( 'Reserviert          ', '', ''),
        ( 'CD eingelegt        ', Ja, Nein),
        ( 'R-W-Sub-Kanle      ', Nein, Ja ));

TYPE
    DWord =          RECORD CASE BOOLEAN OF
                         TRUE   :  ( LoWord, HiWord: WORD);
                         FALSE  :  ( L: LongInt);
                     END;
    TDevName =       ARRAY [1..8] OF CHAR;
    TRequestHeader = RECORD
                         Len          : BYTE;
                         SubUnit      : BYTE;
                         CommandCode  : BYTE;
                         Status       : WORD;
                         DevName      : TDevName;
                     END;
    TIOCTLO =        RECORD
                         RequestHeader   : TRequestHeader;
                         MediaDescriptor : BYTE;
                         Buffer          : POINTER;
                         BufferSize      : WORD;
                         StartSector     : WORD;
                         VolumePtr       : DWord;
                     END;
    TDeviceStatus =  RECORD
                         Command : BYTE;
                         Status  : DWord;
                     END;

    TIOPLAY =        RECORD
                         RequestHeader   : TRequestHeader;
                         AdressMode      : BYTE;
                         StartSector     : POINTER;
                         Sectors         : Word;
                     END;

VAR
   Regs          : Registers;
   IO            : TIOCTLO;
   DeviceNr      : Word;
   DeviceStatus  : TDeviceStatus;
   C             : BYTE;
   CopyRight     : Array[0..39] Of Byte;
   i             : Integer;
   wahl          : Char;

   PLAY          : TIOPLAY;


PROCEDURE Stop(Message : STRING);
BEGIN
     Writeln( Message);
     HALT
END;

(* Ermitteln der MSCDEX Version *)
Procedure ShowMSCDEXInfo;
Begin
     Regs.AX  := $150C;
     Regs.BX  := $0;
     Intr($2F, Regs);
     Writeln('MSCDEX Treiber Version : ',Regs.BH,'.',Regs.BL);
     Writeln;
End;

(* Ermittelt Anzahl der Laufwerke und Nummer des ersten Laufwerks *)
Procedure ShowDriveInfo;
Begin
     Regs.AX  := $1500;
     Regs.BX  := $0;
     Intr($2F, Regs);
     IF (Regs.BX = 0) THEN
         Stop('No CD-ROM-Drive found ... ');

     Writeln(Regs.BX,' CD ROM Drives found.');
     Writeln('Drive Letter = ',Chr(65 + Regs.CX),':');
     Writeln;

     DeviceNr := Regs.CX;
End;

(* Zugriff auf Laufwerkstreiber und Statusblock *)
Procedure ShowInfo;
Begin
     ClrScr;

     FiLLChar(IO, SizeOf(IO), 0);
     WITH IO DO
     BEGIN
          RequestHeader.Len         := SizeOf(TIOCTLO);
          RequestHeader.CommandCode := 3;
          Buffer                    := @DeviceStatus;
          BufferSize                := SizeOf( DeviceStatus);
          DeviceStatus.Command      := 6;
          DeviceStatus.Status.L     := 0;
     END;

     Regs.AX := $1510;
     Regs.BX := Ofs(IO);
     Regs.ES := Seg(IO);
     Intr($2F, Regs);
     Writeln('Laufwerks Informationen');

     C:= 0;
     WHILE ( C <= MaxFeatures) DO
     BEGIN
          Write(Features [C, 1] + ' ');
          IF ((DeviceStatus. Status. LoWord AND $1) = 0) THEN
              Write(Features[C, 2])
          ELSE
              Write(Features[C, 3]);
          DeviceStatus.Status.L := DeviceStatus.Status.L SHR 1;
          Writeln;
          INC( C);
     END;

     wahl := ReadKey;
End;


(* Audio Daten spielen *)
Procedure PlayAudio;
Begin
     FiLLChar(PLAY, SizeOf(PLAY), 0);

     PLAY.RequestHeader.CommandCode := 132;
     {
     PLAY.RequestHeader   := ;
     PLAY.AdressMode      : BYTE;
     }
     PLAY.StartSector     := Nil;
     PLAY.Sectors         := 10000;


     Regs.CX := DeviceNr;
     Regs.AX := $1510;
     Regs.BX := Ofs(PLAY);
     Regs.ES := Seg(PLAY);
     Intr($2F, Regs);
End;

(* Audio halt *)
Procedure HaltAudio;
Begin
     FiLLChar(PLAY, SizeOf(PLAY), 0);

     PLAY.RequestHeader.CommandCode := 133;

     Regs.CX := DeviceNr;
     Regs.AX := $1510;
     Regs.BX := Ofs(PLAY);
     Regs.ES := Seg(PLAY);
     Intr($2F, Regs);
End;

(* Audio stop *)
Procedure StopAudio;
Begin
     FiLLChar(PLAY, SizeOf(PLAY), 0);
     PLAY.RequestHeader.CommandCode := 133;

     Regs.CX := DeviceNr;
     Regs.AX := $1510;
     Regs.BX := Ofs(PLAY);
     Regs.ES := Seg(PLAY);
     Intr($2F, Regs);

     FiLLChar(PLAY, SizeOf(PLAY), 0);
     PLAY.RequestHeader.CommandCode := 133;

     Regs.AX := $1510;
     Regs.BX := Ofs(PLAY);
     Regs.ES := Seg(PLAY);
     Intr($2F, Regs);
End;

(* Audio weiterspielen *)
Procedure ContinueAudio;
Begin
     FiLLChar(PLAY, SizeOf(PLAY), 0);

     PLAY.RequestHeader.CommandCode := 136;

     Regs.CX := DeviceNr;
     Regs.AX := $1510;
     Regs.BX := Ofs(PLAY);
     Regs.ES := Seg(PLAY);
     Intr($2F, Regs);
End;

BEGIN
     Repeat
           ClrScr;
           Writeln('Small DOS CD Audio Player (c)13.10.1993/ Ct');
           Writeln;

           ShowMSCDEXInfo;
           ShowDriveInfo;

           Writeln('  1  -     Play  Audio CD');
           Writeln('  2  -     Pause');
           Writeln('  3  -     Cont');
           Writeln('  4  -     Stop');
           Writeln;
           Writeln('  9  -     CD Drive Info');
           Writeln;
           Writeln('  0  -     Exit Program');

           Repeat Until KeyPressed;

           wahl := ReadKey;
           Case wahl Of
            '1' : PlayAudio;
            '2' : HaltAudio;
            '3' : ContinueAudio;
            '4' : StopAudio;
            '9' : ShowInfo;
           End;
     Until (wahl = '0') Or (wahl = ' ') Or (wahl = Chr(13));
END.

