{ Uart startklar machen auf COM2 }
procedure cd_init_uart;
 begin
  SetUart(2,38400,pnone,8,1);
  ActivateCom(2,1000,false);
 end;

{ Holt einen String von COM2 rein, false wenn innherhalb 20 Sekunden nix kam }
function cd_get_string (var txt : string) : boolean;
var zeichen :  byte;
    dauer   : word;
 begin
  txt:='';
  dauer:=0;

  repeat
   zeichen:=0;
   if not receive(2,zeichen) then

    begin   { Kein Zeichen empfangen }
     delay (5);
     inc (dauer);
     zeichen:=0;
    end else

    begin  { Zeichen empfangen }
     txt:=txt+chr (zeichen);
     dauer:=0;
    end;

  until (dauer>2000) or (zeichen=13);
  txt [length (txt)]:=#13;

  { writeln ('Eingelesen : ',txt); }

  cd_get_string:=(dauer<2000);
 end;

{ Cd-Status reinholen }
procedure cd_get_status;
var comstri : string;
 begin
  SendByte(2,ord ('S'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Statusabfrage');
  cd_eingelegt:=(comstri [8]='I');
  tuer_offen:=(comstri [7]='O');
  cd_typ_audio:=(comstri [9]='A');
  wiedergabe_laeuft:=(comstri [10]='P');
 end;

{ Schublade ffnen }
procedure cd_open;
var comstri : string;
 begin
  SendByte(2,ord ('O'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort ffnen');
  writeln (comstri);
 end;

{ Schublade schliessen }
procedure cd_close;
var comstri: string;
 begin
  SendByte(2,ord ('C'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort schliessen');
  writeln (comstri);
 end;

{ CD spielen }
procedure cd_play;
var comstri: string;
 begin
  SendByte(2,ord ('P'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort abspielen');
  writeln (comstri);
 end;

{ CD stoppen }
procedure cd_stop;
var comstri: string;
 begin
  SendByte(2,ord ('Q'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Stop');
  writeln (comstri);
 end;

{ CD Skip + }
procedure cd_skip_forward;
var comstri: string;
 begin
  SendByte(2,ord ('+'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Skip +');
  writeln (comstri);
 end;

{ CD Skip - }
procedure cd_skip_back;
var comstri: string;
 begin
  SendByte(2,ord ('-'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Skip -');
  writeln (comstri);
 end;

{ CD pause }
procedure cd_pause;
var comstri: string;
 begin
  SendByte(2,ord ('B'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Pause');
  writeln (comstri);
 end;

{ CD Resume }
procedure cd_resume;
var comstri: string;
 begin
  SendByte(2,ord ('B'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Resume');
  writeln (comstri);
 end;


{ CD Aktuelle Laufzeit holen }
procedure cd_get_time;
var comstri: string;
 begin
  SendByte(2,ord ('T'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Get Time');
  writeln (comstri);

  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Get Time');
  writeln (comstri);
  aktueller_track:=asc2byte (copy (comstri,9,3));

  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Get Time');
  writeln (comstri);
  aktueller_index:=asc2byte (copy (comstri,9,3));

  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Get Time');
  writeln (comstri);
  aktuelle_minute:=asc2byte (copy (comstri,7,3));

  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Get Time');
  writeln (comstri);
  aktuelle_sekunde:=asc2byte (copy (comstri,7,3));

 end;


{ CD Information holen }
procedure cd_get_info;
var comstri: string;
 begin
  SendByte(2,ord ('A'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Get Info');
  writeln (comstri);

  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Get Info');
  writeln (comstri);

  { Ab hier gibts die Information }
  trackanzahl:=1;
  repeat

   if not cd_get_string (comstri) then fatal_error ('Keine Antwort Get Info');
   { write (comstri); }

   { String zerlegen }
   if (pos ('Ende',comstri)<>1) then
    begin
     trackanzahl:=asc2byte (copy (comstri,1,3));
     { writeln ('Sting : ',copy (comstri,1,3),' ',trackanzahl); }
     trackinfo [trackanzahl].number:=trackanzahl;
     trackinfo [trackanzahl].min:=asc2byte (copy (comstri,5,3));
     trackinfo [trackanzahl].sec:=asc2byte (copy (comstri,9,3));
     { inc (trackanzahl) }
    end;

  until pos ('Ende',comstri)<>0;

 end;
