unit CSIO;  { aus c't  5.88  S 204 mit Verbesserungen von meinereinem }
Interface
USES Crt,Dos;
const
  comu1   =  $3F8;    { Basisadresse COM1-Portchip}
  comu2   =  $2F8;    { Basisadresse COM2-Portchip}
  comu3   =  $3E8;    { Basisadresse COM3-Portchip}
  comu4   =  $2E8;    { Basisadresse COM4-Portchip}
  ComInt1 =  $0C;     { Int. Einsprung Com1 IRQ 4 }
  ComInt2 =  $0B;     { Int. Einsprung Com2 IRQ 3 }
  ComInt3 =  $0A;     { Int. Einsprung Com3 IRQ 2 bei AT besser nicht verwenden}
  ComInt4 =  $0D;     { Int. Einsprung Com4 IRQ 5 }
  ComInt10=  $72;     { Int. Einsprung IRQ 10     }
  ComInt11=  $73;
  ComInt12=  $74;
  IntContr: integer = $20; { Common Register Interrupt-Controller }
  IntContr1         = $20; { Interrupt Controller 1 (Master) }
  IRQ_Mask: integer = $21; { Mask Register   Interrupt-Controller }
  EOI:      byte    = $20; { Meldung 'Aktueller IORQ abgearbeitet ' }
                           { muss IRQ abschliessen                    }
  BuffTop  =  1024;    { Maximale Puffergroesse in Byte }
  MC_DTR     = $01;       { Modem Control Register }

Type
    ParTyp   = (n,e,o);
    DBitTyp  = 5..8;
    SbitTyp  = 1..2;
Var
   ComInt  :  Byte ;  { Hier muss Nummer des Interrupts rein !!!!!!        }
   Com     :  Word ;  { Hier muss die Basisadresse des PortChips rein !!   }
   AltCom          :  Pointer;    { Hier wird alter Int.-Vektor abgelegt  }
   SioExitSave     :  Pointer;    { und hier die Adresse des Exithandlers }
   EinZeiger,AusZeiger  : Word;
   MaskOn,MaskOff       : Byte;
   InBuff               : Array [0..BuffTop] of byte;

{*****************************************}
{ Lesen eines Bytes aus dem Eingabepuffer }
{ pb gibt an ob ein Wert vorhanden war    }
{*****************************************}
Function InByte (var pb: Boolean):Byte;

{*****************************************}
{ Initialisieren der SIO                  }
{ BasisPort : Comu1 oder Comu2            }
{ Baud      : Baudrate                    }
{ DataBits  : 5, 6, 7 oder 8              }
{ StopBits  : 1 oder 2                    }
{ Parit     : Paritaet  e, o oder n        }
{*****************************************}
Procedure Initcom (Baud:Real; DataBits:DBitTyp;
                   StopBits:SBitTyp; Parit:ParTyp);

{********************************************}
{ Get_Status fragt den Status der SIO ab und }
{ uebergibt im oberen Byte den 'MODEM-Status' }
{ und im untern Byte den Line-Status         }
{********************************************}
Function Get_Status:Word;

{************************************}
{ Write_SIO gibt Zeichen an Sio aus  }
{ wobei der Status der SIO nicht     }
{ vorher abgefragt wird !            }
{************************************}
Procedure Write_SIO (Datum : Byte);
(* Dito, nur wenn SIO bereit *)
Procedure Write_SIO_Status (Datum : Byte);

{***************************************}
{ Read_Byte liest ein Byte von der SIO. }
{ Time_Out gibt an wieviele ms auf ein  }
{ Zeichen gewartet werden soll. Wird    }
{ innerhalb der angegebenen Zeit kein   }
{ Zeichen empfangen, so wird die Flag   }
{ ERR_FLAG gesetzt. Wird aber ein       }
{ Zeichen empfangen, so wird diese      }
{ Flag geloescht.                       }
{***************************************}
Function Read_Byte (Time_Out:Word;var Err_Flag:Boolean):Byte;

{**************************************************}
{* Diese Procedur muss ,nachdem die Variablen COM *}
{* und COMINT initialisiert wurden, aufgerufen    *}
{* werden, da sie den Interruptvektor setzt       *}
{**************************************************}
Procedure SIO_UNIT_INIT;

{ DTR als Reset-Impuls fr den RS485-Konverter }
procedure SetDtr;                  { DTR=1 setzen      }
procedure dropDtr;                  { DTR=1 setzen      }

Implementation

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure DropDtr;                 { DTR=0 setzen      }
begin
  port[com+4]:=port[com+4] and (not MC_DTR);
end;

procedure SetDtr;                  { DTR=1 setzen      }
begin
  port[com+4]:=port[com+4] or MC_DTR;
end;


Procedure Write_SIO (Datum : Byte);
Begin
 Port [com] := Datum;
End;


Function Get_Status:Word;
var  temp : Word;
Begin
  temp := swap (Port [com+6]);
  temp := temp + Port [com+5];
  Get_Status := temp;
End;

Procedure ReadCom;
  Interrupt;
Begin
  Inc (EinZeiger);
  If  (EinZeiger > BuffTop) Then EinZeiger:=0;
  InBuff[EinZeiger]:=Port[com];
  Port[IntContr]:=EOI;
  If IntContr <> IntContr1 then Port[IntContr1] := EOI;
end;


Function InByte(var pb: Boolean):Byte;
Begin
  pb := (Auszeiger<>Einzeiger);
  if pb then
    Begin
      inc (AusZeiger);
      if Auszeiger>Bufftop then Auszeiger:=0;
      inbyte:=Inbuff[AusZeiger];
    end;
end;

Procedure SioInt_aus;
Begin
 Port[IRQ_Mask] := Port [IRQ_Mask] or MaskOff;
end;

Procedure SioInt_ein;
Begin
 Port[IRQ_Mask] := Port [IRQ_Mask] and MaskOn;
end;

Procedure Initcom ( Baud:Real; DataBits:DBitTyp;
                   StopBits:SBitTyp; Parit:ParTyp);

var  divisor : integer;
     local   :  byte;
     dummy   : word;
Begin
  SIOInt_AUS;
  divisor := round (115200.0 / Baud);
  port [com+3] := $80;
  port [com]   := lo (divisor);
  port [com+1] := hi (divisor);
  local := 0;
  Case DataBits of  8 :  local := 3;
                    7 :  local := 2;
                    6 :  local := 1;
                    end;
  If (StopBits = 2) then local := local or $04;
  Case Parit of     e :  local := local or $18;
                    o :  local := local or $08;
                    end;
 port [com+3] := local;
 port [com+1] := 1;    {nur Empfangsinterrupt}
 port [com+4] := $0B;
 local := port [com];
 SioInt_EIN;
 dummy := Get_status ;
end;


{$F+} Procedure SioExit; {f-}
var Dummy : Byte;

begin
  SioInt_aus;
  Dummy:=Port[com];
  Setintvec(ComInt,altcom);
  Exitproc:=SioExitsave;
end;

Procedure SIO_UNIT_INIT;
Begin
  case ComInt of
                 $0C :  Begin
                          MaskOn  := $EF;
                          MAskOff := $10;
                        End;
                 $0B :  Begin
                          MaskOn  := $F7;
                          MAskOff := $08;
                        End;
                 $0A :  Begin
                          MaskOn  := $FB;
                          MAskOff := $04;
                        End;
                 $0D :  Begin
                          MaskOn  := $DF;
                          MAskOff := $20;
                        End;
                 $72  : Begin
                          MaskOn  := $FB;
                          MaskOff := $04;
                          IntContr := $A0;
                          IRQ_Mask := $A1;
                        End;
                $73  : Begin
                          MaskOn  := $F7;
                          MaskOff := $08;
                          IntContr := $A0;
                          IRQ_Mask := $A1;
                        End;
                $74  : Begin
                          MaskOn  := $EF;
                          MaskOff := $10;
                          IntContr := $A0;
                          IRQ_Mask := $A1;
                        End;
                Else Begin
                   Writeln (' falscher IRQ ! ');
                   Halt (1);
                End;
                end;
  Sioint_AUS;
  SioExitSave := ExitProc;
  ExitProc    := @SioExit;
  getintvec (comint,altcom);
  setintvec (comint,@readcom);
  einzeiger := 0;
  auszeiger := 0;
end;

Function Read_Byte (Time_Out:Word;var Err_Flag:Boolean):Byte;
var  Dummy  : Byte;
     FDummy : Boolean;
Begin
  Repeat
    Dummy := InByte (FDummy);
    dec (Time_Out);
    Delay (1);
  Until FDummy or (Time_Out = 0);
  { if fdummy then write ('t') else write ('f'); }
  If Fdummy then
    BEgin
      Err_Flag := False;
      Read_Byte := Dummy;
    End
  Else Err_Flag := True;
end;

(**********************************************************)

Procedure Write_SIO_Status (Datum : Byte);
Const FREE = $0040;
Begin
  Repeat Until (Get_Status And FREE) <> 0;
  Write_SIO (Datum);
End;


Begin
end.


