{ Display identifizieren }
function display_identify (adress : byte) : boolean;
 begin
  write_sio_status (adress);    { Adresse der Lampe senden }
  write_sio_status (d_identify);{ Befehl senden }
  write_sio_status ($00);       { Es folgen keine Parameter }

  write_sio_status ($02);       { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge vom Display }
  display_identify:=get_acknowledge (adress,l_identify,0);

 end;

{ Schaltet die Hintergrundbeleuchtung vom Display }
function display_light (zeichen : byte) : boolean;
 begin
  write_sio_status (adress_display_big);       { Adresse des Displays senden }
  write_sio_status (d_light);                  { Befehl senden }
  write_sio_status ($01);                      { Es folgt ein Parameter }
  write_sio_status (zeichen);                  { Parameter }
  write_sio_status ($02);                      { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge }
  rescon:=false;
  display_light:=get_acknowledge (adress_display_big,d_light,1);
  rescon:=true;
 end;


{ bertrgt eine Zeichenkette zum groen Display }
{ Null-terminiert }
function write_char_display_big (zeile : byte;zeichenkette : string) : boolean;

var zi : byte;
    zpuf : string;

 begin

  zpuf:=zeichenkette;

  write_sio_status (adress_display_big);       { Adresse des Displays senden }
  write_sio_status (d_sendchar);               { Befehl senden }

  write_sio_status (length (zpuf)+2);    { Es folgen x Parameter }

  write_sio_status (zeile);

  for zi:=1 to length (zpuf) do
   write_sio_status (ord (zpuf [zi])); { zeichen }

  write_sio_status ($00);                       { Es folgt das Ende }

  write_sio_status ($02);                      { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge }
  rescon:=false;
  write_char_display_big:=get_acknowledge (adress_display_big,d_sendchar,1);
  rescon:=true;
 end;


function write_command_display_big (zeile,zeichen : byte) : boolean;
{ bertrgt ein Kommando zum groen Display }
 begin
  write_sio_status (adress_display_big);       { Adresse des Displays senden }
  write_sio_status (d_sendcommand);            { Befehl senden }
  write_sio_status ($02);                      { Es folgen zwei Parameter }
  write_sio_status (zeile);                    { Parameter }
  write_sio_status (zeichen);                  { Parameter }
  write_sio_status ($02);                      { Es mssen zwei Bytes zurckkommen }

  { Warten auf das Acknowledge }
  rescon:=false;
  write_command_display_big:=get_acknowledge (adress_display_big,d_sendcommand,1);
  rescon:=true;
 end;


{ Positioniert den Cursor des groen Displays }
{ Zeilen 0..3, Spalten 0..39 }
function set_cursor_display_big (x,y : byte) : boolean;
var zeile,spalte : byte;
 begin

  { Richtigen Controller herausuchen }
  if y<=1 then zeile:=0 else zeile:=1;

  { Adresse berechnen }
  spalte:=128 + x;
  if ((y=1) or (y=3)) then spalte:=spalte+64;

  set_cursor_display_big:=
   write_command_display_big (zeile,spalte);

 end;

{ Lscht das Display, Cursor home }
procedure big_display_clear;
 begin
  fillchar (display_big_buffer [0][0],sizeof (display_big_buffer),32);
  fillchar (display_big_buffer_old [0][0],sizeof (display_big_buffer_old),32);
  write_command_display_big (0,1); { Zeile 0/1 lschen }
  write_command_display_big (1,1); { Zeile 2/3 lschen }
 end;


{ Groes Display initialisieren }
procedure big_display_init;
var dummy : boolean;
 begin
  { Mach mal Licht in dieser Muffbude.... }
  write ('Licht an...');
  dummy:=display_light (1);

  { Puffer fllen }
  fillchar (display_big_buffer_old [0][0],sizeof (display_big_buffer_old),32);
  fillchar (display_big_buffer [0][0],sizeof (display_big_buffer),32);

  { Anzeige lschen }
  write ('Display lschen...');
  big_display_clear;

 end;

{ Aktualisiert das groe Display je nach Pufferzustand }
procedure big_display_refresh;
var zeile,spalte    : byte;
    cursorx,cursory : byte;
    dummystr        : string;
    marker          : byte;
    dzaehl          : byte;

 begin

  { Strategie : Vergleich zwischen altem und neuem Speicher }
  { Sind Unterschiede vorhanden, werden diese als Zeichenkette }
  { bis bis nchsten Gleichheit bertragen }


  { Cursor setzen }
  { cursorx:=0;
  cursory:=0;
  set_cursor_display_big (cursorx,cursory); }


  for zeile:=0 to 3 do
   begin
    writeln ('Zeile : ',zeile);
    spalte:=0;
    while spalte<40 do

     begin

      while ((display_big_buffer_old [spalte][zeile]=
              display_big_buffer [spalte][zeile]) and
              (spalte<=39) ) do
       begin
      {  write ('Alt : ',display_big_buffer_old [spalte][zeile],' ');
        write ('Neu : ',display_big_buffer_old [spalte][zeile],' ');
        writeln ('Spalte : ',spalte,' Zeile : ',zeile); }
        inc (spalte);
       end;

      if spalte<40 then { Unterschied gefunden ? }
       begin
        marker:=spalte;
        while ((display_big_buffer_old [marker][zeile]<>
              display_big_buffer [marker][zeile]) and
              (marker<39) ) do inc (marker);

        { Unterschied von Spalte bis Marker gefunden }
        { Also Isolieren und zum Display bertragen }
        dummystr:='';
        for dzaehl:=spalte to marker-1 do
         dummystr:=dummystr+chr (display_big_buffer [dzaehl][zeile]);

        set_cursor_display_big (spalte,zeile);

        if ((zeile=0) or (zeile=1)) then
         write_char_display_big (0,dummystr) else
         write_char_display_big (1,dummystr);

        { Neue Spalte setzen }
        Spalte:=marker+1;

       end; { von if spalte<40 then }

     end; { von while spalte<40 do }

   end; { von for zeile:=0 to 3 do }

   { Puffer wieder angleichen }
   display_big_buffer_old:=display_big_buffer;

 end;

{ Schreibt einen String in den Puffer des groen Displays }
{ Mit big_display_refresh wird es dann angezeigt          }
procedure big_display_buffer_write (x,y : byte;txt : string);
var px : byte;
 begin
  if y>3 then y:=3;
  if y<0 then y:=0;
  for px:=x to x+length (txt)-1 do
   if px<39 then display_big_buffer [px][y]:=ord (txt [px-x+1]);
 end;


{ Schaltet den Cursor ein/aus }
procedure big_display_cursor (zeile : byte;an,blink : boolean);
var coma : byte;
 begin
  coma:=8+4;
  if an then coma:=coma+2;
  if blink then coma:=coma+1;
  write_command_display_big (zeile,coma);
 end;