(* Fehler : IO, Mischerlampe blau *)

Program Jukebox; { Erstellt mit Turbo Pascal 6.0 }

uses dos,crt,csio,seriell;

     { Informationen zur CD }
type trkifo             = record
                           number,min,sec : byte;
                          end;

const   { Timeout in ms fr CSIO }
        CTimeOut                 : word = 70;

        { resetdauer fr konverter }
        Reset_delay              = 100;

        { Motoradressen }
        adress_heber             : byte = $A5;
        adress_teller            : byte = $A0;
        adress_schwenker         : byte = $A2;
        adress_dreher            : byte = $A3;
        adress_greifer           : byte = $A1;

        { Motorbefehle }
        m_goref                  : byte = $01;
        m_stepforward            : byte = $02;
        m_stepback               : byte = $03;
        m_identify               : byte = $04;

        {----------------------------------------------------}

        { Lampenadressen }
        adress_lampe_top_left    : byte = $C0;
        adress_lampe_top_right   : byte = $C1;
        adress_mischer_rot       : byte = $C2;
        adress_mischer_gruen     : byte = $C3;
        adress_mischer_blau      : byte = $C5;
        adress_mischer_gelb      : byte = $C4;

        { Lampenbefehle }
        l_switch                 : byte = $01;
        l_dimmrel                : byte = $03;
        l_dimmabs                : byte = $02;
        l_identify               : byte = $04;

        {----------------------------------------------------}

        { Tastaturadresse }
        adress_keyboard          : byte = $D0;

        { Tastaturbefehle }
        k_getchar                 : byte = $01;
        k_identify                : byte = $04;
        k_light                   : byte = $05;
        k_flush                   : byte = $06;
        k_lock                    : byte = $07;

        {--------------------------------------}

        { Displayadressen }
        adress_display_big       : byte = $B0;

        { Displaybefehle }
        d_sendchar               : byte = $01;
        d_sendcommand            : byte = $02;
        d_identify               : byte = $04;
        d_light                  : byte = $05;

        {--------------------------------------}

        { IO-Adresse }
        adress_IO                : byte = $90;

        { IO-Befehle }
        i_light                  : byte = $01;
        i_identify               : byte = $04;
        i_sensor                 : byte = $02;

        {----------------------------------------------------}

        { Schrittpositionen Teller entsprechend der CD-Nummer }
        tellerposition : array [1..12] of word =
         (0,269,565,835,1135,1425,1675,1990,2262,2525,2825,3085);

        { Schrittposition Greifer entsprechend Position geschlossen }
        greiferposition : word = 8800;

        { Schrittposition Heber entsprechend Position oben }
        heberposition : word = 4800;

        { Schrittpositionen Schwenker entsprechend links, oben, rechts }
        schwenkerposition : array [1..3] of word = (300,280,196);

        { Schrittpositionen Dreher entsprechend einlegen, herausnehmen }
        dreherposition : array [1..2] of word = (40,320);


        {------------ Typen ------------------}

type    disbuf = array [0..40,0..4] of byte;

        {----------- Variablen ---------------}

var     { Vorhandene Hardware }
        heber, schwenker, dreher, Teller, greifer,
        lampe_oben_links, lampe_oben_rechts,
        lampe_mischer_rot,lampe_mischer_gruen,
        lampe_mischer_blau,lampe_mischer_gelb,
        display,keyboard,io                             : boolean;

        { Vorhandene Harwaregruppen }
        motoren, lampen, displays, IOs, keyboards       : boolean;

        { Aktuelle Schrittpositionen }
        schrittpos                                      : array [1..10] of longint;

        { Puffer fr das groe Display }
        display_big_buffer,display_big_buffer_old       : disbuf;

        { Universelles Zeug }
        ch                                              : char;
        azaehler                                        : integer;
        bzaehler                                        : integer;

        { CD-bezogene Variablen }

        { Aktueller Status des Laufwerks }
        cd_eingelegt,tuer_offen                     : Boolean;
        cd_typ_audio                                : boolean;
        wiedergabe_laeuft                           : boolean;
        cd_nummer                                   : byte;
        cd_modus                                    : byte;
        benutzer_modus                              : boolean;
        cd_ende                                     : boolean;
        aktuelle_sekunde_alt                        : byte;
        aktuelle_minute_alt                         : byte;
        aktueller_track_alt                         : byte;

        aktueller_track, aktueller_index            : byte;
        aktuelle_minute, aktuelle_sekunde           : byte;
        minuten_gesamt                              : integer;
        sekunden_gesamt                             : integer;
        temp_wiedergabe_laeuft                      : boolean;

        trackinfo                                   : array[1..100] of trkifo;
        trackanzahl                                 : byte;

        { Von der Tastatur geliefertes Zeichen }
        keyboard_key                                : byte;
        pc_key                                      : char;

        { Bestimmt, ob RS285-Konverter zurckgesetzt wird }
        rescon                                      : boolean;

        { Variablen Hauptprogramm }
        cursorx,cursory                             : byte;
        keyb                                        : char;
        zaehler                                     : integer;

        { Showeffekte }
        durchlauf                                   : integer;
        showcount                                   : integer;

{-----------------------------}
{ Status- und Fehlermeldungen }
{-----------------------------}

{ Alles im ARSCH }
procedure fatal_error (txt : string);
 begin
  writeln (txt);
  writeln (#10#13,'Programm abgebrochen mit Fehlercode 255');
  halt (255);
 end;

{ Meldung ausgeben }
procedure meldung (txt : string);
 begin
  writeln (txt);
 end;

{ Fehler ausgeben }
procedure fehler (txt : string;warning : boolean);
var ch : char;
 begin
  if warning then write ('Warnung : ') else write ('Fehler : ');
  write (txt,'  ');

  if warning then
   begin
    write ('Weitermachen (j/n) ');
    repeat
     ch:=readkey;
    until ch in ['j','n','J','N'];
    if upcase (ch)='N' then
     begin
      writeln (#10#13,'Programm abgebrochen mit Fehlercode 255');
      halt (255);
     end else writeln ('J');

   end else writeln;

 end;

{-----------------}
{ Anzeigeoptionen }
{-----------------}
function asc2byte (txt : string) : byte;
var valerror : integer;
    zahl     : byte;
    puffer   : string;
 begin
  puffer:=txt;
  {
  while (length (puffer)>0) and (pos ('0',puffer)<>0 ) do
   delete (puffer,pos ('0',puffer),1); }

  while (length (puffer)>0) and (pos (' ',puffer)<>0 ) do
   delete (puffer,pos (' ',puffer),1);
  val (puffer,zahl,valerror);
  asc2byte:=zahl;

 end;

function byte2asc (hin : byte) : string;
var buf : string;
    puf,divi : byte;

 begin
  buf:='';
  puf:=hin;

  { 100 }
  divi:=puf div 100;
  puf:=puf- (divi*100);
  buf:=buf+chr (divi+48);

  { 10 }
  divi:=puf div 10;
  puf:=puf- (divi*10);
  buf:=buf+chr (divi+48);

  { 1 }
  buf:=buf+chr (puf+48);

  byte2asc:=buf;
 end;


{-----------------------}
{ Reset-Impuls erzeugen }
{-----------------------}
procedure reset_konverter;
var dummy : byte;
    flag  : boolean;

 begin

  { Negative Flanke am Controller erzeugen }
  dropdtr;
  delay (Reset_delay);
  setdtr;
  delay (Reset_delay);

  { Puffer leeren, falls noch was im der Rhre schlummert.... }
  repeat
   dummy:=read_byte (100,flag);
  until flag;

  delay (Reset_delay);

 end;

{---------------------------------------------}
{ Warten auf das Acknowledge der RS485-Slaves }
{---------------------------------------------}
function get_acknowledge (adress,command,time : byte) : boolean;
var ack_adress, ack_command : byte;
    timeout                 : integer;
    flag                    : boolean;
    inbytes                 : array [1..8] of byte;
    incount                 : byte;
    ack_temp                : byte;
    dummy_ack               : boolean;

 begin

  { Warten auf die zwei Acknowledge-Zeichen Adresse und Kommando }

  incount:=1;
  flag:=false;
  fillchar (inbytes [1],8,32);

  { Zeichen reinholen }
  while ( (incount<=8) and (flag=false) ) do
   begin

    { Das untere Bit entscheidetm, ob endlos gelesen wird }
    if (time and 1)=0 then inbytes [incount]:=read_byte (CTimeOut,flag);
    if (time and 1)=1 then
     repeat
      inbytes [incount]:=read_byte (CTimeOut,flag);
     until not flag;


    { write (inbytes [incount],' '); }
    write (incount,' ');
    if flag then write ('T') else write ('F');
    inc (incount);
   end;
   { writeln; }

   write (#10#13,'Bytes : ');
   for incount:=1 to 8 do write (inbytes [incount],' ');

   { Adressen zusammensetzen }
    {$r-}
   if (chr (inbytes [1]) in ['A'..'F']) then
    inbytes [1]:=inbytes [1]-55 else
    inbytes [1]:=inbytes [1]-48;
   if (chr (inbytes [2]) in ['A'..'F']) then
    inbytes [2]:=inbytes [2]-55 else
    inbytes [2]:=inbytes [2]-48;
   if (chr (inbytes [5]) in ['A'..'F']) then
    inbytes [5]:=inbytes [5]-55 else
    inbytes [5]:=inbytes [5]-48;
   if (chr (inbytes [6]) in ['A'..'F']) then
    inbytes [6]:=inbytes [6]-55 else
    inbytes [6]:=inbytes [6]-48;

   ack_adress:=inbytes [1]*16+inbytes[2];
   ack_command:=inbytes [5]*16+inbytes[6];
    {$r+}
   { Hier erst einmal die oberen Bits ausmaskieren, spter bentigt fr
     die Tastaturdaten etc }
  ack_temp:=ack_command; { Zwischenspeichern }
  ack_command:=(ack_command AND $0F);

  { Beides richtig ? }
  dummy_ack:=( (ack_adress=adress) AND (ack_command=command) );
  get_acknowledge:=dummy_ack;

  { if rescon then }
  if not dummy_ack then reset_konverter;

  { Jetzt noch feststellen, ob die oberen Bits zurckgegeben werden sollen }
  keyboard_key:=ack_temp AND $F0;
  {$r-}
  {keyboard_key:=(keyboard_key shr 4); }
  {$r+}
 end;

{-------------------------------------------------------------------}
{ Motorkontrolle                                                    }
{-------------------------------------------------------------------}
{$i motor.inc }

{-------------------------------------------------------------------}
{ Lampenkontrolle                                                   }
{-------------------------------------------------------------------}
{$i lampe.inc }

{---------------------------------------------------------------------}
{ Displaykontrolle                                                    }
{---------------------------------------------------------------------}
{$i display.inc }

{---------------------------------------------------------------------}
{ Keyboardkontrolle                                                   }
{---------------------------------------------------------------------}
{$i keyb.inc }

{---------------------------------------------------------------------}
{ IOkontrolle                                                         }
{---------------------------------------------------------------------}
{$i io.inc }

{--------------------------------------------------------------------}
{ CD-Steuerungs-Funktionen                                              }
{--------------------------------------------------------------------}
{$i cd_kont.inc }

{-------------------------------------------------------------------}
{ Initialisierungen                                                 }
{-------------------------------------------------------------------}
{$i init.inc }

{--------------------------------------------------------------------}
{ Debug-Funktionen                                                   }
{--------------------------------------------------------------------}
{$i debug.inc }

{--------------------------------------------------------------------}
{ Steuerungs-Funktionen                                              }
{--------------------------------------------------------------------}
{$i steuerng.inc }

{----------------------------------------------------------------}
{ Normale Operation                                              }
{----------------------------------------------------------------}
{$i nop.inc }

{-----------------------------------------------}
{ Und das hier macht die Arbeit vons janze..... }
{-----------------------------------------------}
procedure main;
 begin
  writeln ('Hauptsteuerung aktiviert....');

  durchlauf:=0;
  showcount:=0;

  { Testen, ob eine CD im Laufwerk ist }
  cd_get_status;
  if tuer_offen then
   begin
    writeln ('Schublade offen, wird geschlossen. ');
    cd_close;
    delay (5000);
    cd_get_status;
   end;

   if keyboard_flush then writeln ('Keyboard Puffer leer')
    else writeln ('Keyboardfehler');

  big_display_cursor (0,false,false);
  big_display_cursor (1,false,false);

  if cd_eingelegt then
   begin

    { Licht in der Bude machen.... }
    if lamp_dimm_absolut (adress_lampe_top_left,20,80,3) then writeln ('Lampe oben links angesteuert')
      else writeln ('Lampenfehler oben links');
    if lamp_dimm_absolut (adress_lampe_top_right,20,80,3) then writeln ('Lampe oben rechte angesteuert')
      else writeln ('Lampenfehler oben rechts');

    writeln ('CD ist eingelegt, mu manuell entfernt werden');
    cd_open;
    big_display_clear;
    big_display_buffer_write (6,1,'CD bitte manuell entnehmen');
    big_display_buffer_write (12,2,'dann OK druecken');
    big_display_refresh;
    repeat
     keyboard_getchar;
    until keyboard_key<>0;
    if keyboard_flush then writeln ('Keyboard Puffer leer')
     else writeln ('Keyboardfehler');

    { Schn das Licht ausmachen .... }
    if lamp_dimm_absolut (adress_lampe_top_left,80,20,3) then writeln ('Lampe oben links angesteuert')
      else writeln ('Lampenfehler oben links');

     if lamp_dimm_absolut (adress_lampe_top_right,80,20,3) then writeln ('Lampe oben rechte angesteuert')
       else writeln ('Lampenfehler oben rechts');


    cd_close;
   end;

   if keyboard_flush then writeln ('Keyboard Puffer leer')
    else writeln ('Keyboardfehler');


  { Motoren auf Refpos fahren }
  big_display_clear;
  big_display_buffer_write (8,1,'Jukebox (C) Finger 2002');
  big_display_buffer_write (13,2,'Bitte warten !');
  display_light (1);   { Licht einschalten }
  big_display_refresh; { Text ausgeben }

  { Seitenlicht animiert einschalten }
  write_char_io (7);
  delay (300);
  write_char_io (24+7);
  delay (300);
  write_char_io (96+24+7);
  delay (300);
  write_char_io (255);

  { Licht in der Bude machen.... }
  { if lamp_dimm_absolut (adress_lampe_top_left,20,80,3) then writeln ('Lampe oben links angesteuert')
    else writeln ('Lampenfehler oben links');

  if lamp_dimm_absolut (adress_lampe_top_right,20,80,3) then writeln ('Lampe oben rechte angesteuert')
    else writeln ('Lampenfehler oben rechts'); }
  delay (1000);

  steuerung_startpos;

  { Schn das Licht ausmachen .... }
  { if lamp_dimm_absolut (adress_lampe_top_left,80,20,3) then writeln ('Lampe oben links angesteuert')
    else writeln ('Lampenfehler oben links');

  if lamp_dimm_absolut (adress_lampe_top_right,80,20,3) then writeln ('Lampe oben rechte angesteuert')
    else writeln ('Lampenfehler oben rechts'); }
  delay (1000);

  { So, nu simma startklar }
  big_display_buffer_write (13,2,'              ');
  big_display_refresh; { Text ausgeben }

  { Noch das Leuchtfeuer an.... }
  lamp_dimm_absolut (adress_mischer_rot,0,100,3);
  lamp_dimm_absolut (adress_mischer_gruen,0,100,3);

  { Do the funky stuff......... }
  normal_operation;

 end;

{ Eine erste Meldung auf dem Display ausgeben }
procedure startmeldung;
 begin
  big_display_clear;
  big_display_buffer_write (8,1,'Jukebox (C) Finger 2002');
  big_display_buffer_write (9,2,'Softwareversion 1.01');
  big_display_buffer_write (6,3,'Bitte Startsequenz abwarten');
  display_light (1);   { Licht einschalten }
  big_display_refresh; { Text ausgeben }

 end;

{---------------}
{ Hauptprogramm }
{---------------}
begin
 
 startup_init;  { Variablen inititaliseren }
 RS485_init;    { RS485-Hardware klarmachen }
 cd_init_uart;  { Uart fr CD-Kommunikation klarmachen }

 startmeldung;

 { Baustelle ! }
 { do_cd; }

 clrscr;
 writeln ('Taste drcken um ins Debugmen zu gelangen.....');
 writeln ('Start der Hauptfunktion in : ');

 cursorx:=wherex;
 cursory:=wherey;
 zaehler:=5;
 keyb:=#0;

 while ((zaehler>0) and (keyb=#0)) do
  begin
   gotoxy (cursorx,cursory);write (zaehler,' s  ');
   if keypressed then keyb:=readkey;
   if keyb=#0 then delay (1000);
   dec (zaehler);
   end;

 if keyb=#0 then main;


 writeln (#10#13,'Debug-Hauptmen'#10#13);
 writeln ('1. Debug-Funktionen');
 writeln ('2. bergeordnete Steuerung');

   repeat
    ch:=readkey;
   until ( (ch in ['1'..'2']) or (ch=#27) );

   case ch of
    '1' : begin
           debug_menue;
          end;

    '2' : begin
           steuerung_menue;
          end;

   end; { Von Case }

end.

{--------------------------------------------------------------------}

Initialisierung am Start :

CD im Laufwerk
--------------

Keine CD im Laufwerk
--------------------

- Greifer in Refposition
- Dreher in Refposition
- Schwenker in Refposition
- Heber in Refposition
- Teller in Refposition
