program testprog_cd_steuerung;

uses dos,crt,seriell;

type trkifo             = record
                           number,min,sec : byte;
                          end;

var
    { Aktueller Status des Laufwerks }
    cd_eingelegt,tuer_offen                     : Boolean;
    cd_typ_audio                                : boolean;
    wiedergabe_laeuft                           : boolean;

    aktueller_track, aktueller_index            : byte;
    aktuelle_minute, aktuelle_sekunde           : byte;

    trackinfo                                   : array[1..100] of trkifo;
    trackanzahl                                 : byte;

    zaehler                                      : integer;

{-----------------------------}
{ Status- und Fehlermeldungen }
{-----------------------------}

{ Alles im ARSCH }
procedure fatal_error (txt : string);
 begin
  writeln (txt);
  writeln (#10#13,'Programm abgebrochen mit Fehlercode 255');
  ReleaseCom (2);
  halt (255);
 end;

{ Meldung ausgeben }
procedure meldung (txt : string);
 begin
  writeln (txt);
 end;

{ Fehler ausgeben }
procedure fehler (txt : string;warning : boolean);
var ch : char;
 begin
  if warning then write ('Warnung : ') else write ('Fehler : ');
  write (txt,'  ');

  if warning then
   begin
    write ('Weitermachen (j/n) ');
    repeat
     ch:=readkey;
    until ch in ['j','n','J','N'];
    if upcase (ch)='N' then
     begin
      writeln (#10#13,'Programm abgebrochen mit Fehlercode 255');
      halt (255);
     end else writeln ('J');

   end else writeln;

 end;

{-------------------------------------------------------------------------}

function asc2byte (txt : string) : byte;
var valerror : integer;
    zahl     : byte;
    puffer   : string;
 begin
  puffer:=txt;
  while (length (puffer)>0) and (pos ('0',puffer)<>0 ) do
   delete (puffer,pos ('0',puffer),1);
  while (length (puffer)>0) and (pos (' ',puffer)<>0 ) do
   delete (puffer,pos (' ',puffer),1);
  val (puffer,zahl,valerror);
  asc2byte:=zahl;

 end;

function byte2asc (hin : byte) : string;
var buf : string;
    puf,divi : byte;

 begin
  buf:='';
  puf:=hin;

  { 100 }
  divi:=puf div 100;
  puf:=puf- (divi*100);
  buf:=buf+chr (divi+48);

  { 10 }
  divi:=puf div 10;
  puf:=puf- (divi*10);
  buf:=buf+chr (divi+48);

  { 1 }
  buf:=buf+chr (puf+48);

  byte2asc:=buf;
 end;


{ Uart startklar machen auf COM2 }
procedure cd_init_uart;
 begin
  SetUart(2,38400,pnone,8,1);
  ActivateCom(2,1000,false);
 end;

{ Holt einen String von COM2 rein, false wenn innherhalb 20 Sekunden nix kam }
function cd_get_string (var txt : string) : boolean;
var zeichen :  byte;
    dauer   : word;
 begin
  txt:='';
  dauer:=0;

  repeat
   zeichen:=0;
   if not receive(2,zeichen) then

    begin   { Kein Zeichen empfangen }
     delay (5);
     inc (dauer);
     zeichen:=0;
    end else

    begin  { Zeichen empfangen }
     txt:=txt+chr (zeichen);
     dauer:=0;
    end;

  until (dauer>2000) or (zeichen=13);
  txt [length (txt)]:=#13;

  writeln ('Eingelesen : ',txt);

  cd_get_string:=(dauer<2000);
 end;

{ Cd-Status reinholen }
procedure cd_get_status;
var comstri : string;
 begin
  SendByte(2,ord ('S'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Statusabfrage');
  cd_eingelegt:=(comstri [8]='I');
  tuer_offen:=(comstri [7]='O');
  cd_typ_audio:=(comstri [9]='A');
  wiedergabe_laeuft:=(comstri [10]='P');
 end;

{ Schublade ffnen }
procedure cd_open;
var comstri : string;
 begin
  SendByte(2,ord ('O'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort ffnen');
  writeln (comstri);
 end;

{ Schublade schliessen }
procedure cd_close;
var comstri: string;
 begin
  SendByte(2,ord ('C'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort schliessen');
  writeln (comstri);
 end;

{ CD spielen }
procedure cd_play;
var comstri: string;
 begin
  SendByte(2,ord ('P'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort abspielen');
  writeln (comstri);
 end;

{ CD stoppen }
procedure cd_stop;
var comstri: string;
 begin
  SendByte(2,ord ('Q'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Stop');
  writeln (comstri);
 end;

{ CD Skip + }
procedure cd_skip_forward;
var comstri: string;
 begin
  SendByte(2,ord ('+'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Skip +');
  writeln (comstri);
 end;

{ CD Skip - }
procedure cd_skip_back;
var comstri: string;
 begin
  SendByte(2,ord ('-'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Skip -');
  writeln (comstri);
 end;

{ CD pause }
procedure cd_pause;
var comstri: string;
 begin
  SendByte(2,ord ('B'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Pause');
  writeln (comstri);
 end;

{ CD Resume }
procedure cd_resume;
var comstri: string;
 begin
  SendByte(2,ord ('B'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Resume');
  writeln (comstri);
 end;


{ CD Aktuelle Laufzeit holen }
procedure cd_get_time;
var comstri: string;
 begin
  SendByte(2,ord ('T'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Get Time');
  writeln (comstri);

  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Get Time');
  writeln (comstri);
  aktueller_track:=asc2byte (copy (comstri,9,3));

  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Get Time');
  writeln (comstri);
  aktueller_index:=asc2byte (copy (comstri,9,3));

  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Get Time');
  writeln (comstri);
  aktuelle_minute:=asc2byte (copy (comstri,7,3));

  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Get Time');
  writeln (comstri);
  aktuelle_sekunde:=asc2byte (copy (comstri,7,3));

 end;


{ CD Information holen }
procedure cd_get_info;
var comstri: string;
 begin
  SendByte(2,ord ('A'));            { Byte senden }
  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Get Info');
  writeln (comstri);

  if not cd_get_string (comstri) then fatal_error ('Keine Antwort Get Info');
  writeln (comstri);

  { Ab hier gibts die Information }
  trackanzahl:=1;
  repeat
   if not cd_get_string (comstri) then fatal_error ('Keine Antwort Get Info');
   { String zerlegen }
   if pos ('Ende',comstri)=0 then
    begin
     trackanzahl:=asc2byte (copy (comstri,1,3));
     trackinfo [trackanzahl].number:=trackanzahl;
     trackinfo [trackanzahl].min:=asc2byte (copy (comstri,5,3));
     trackinfo [trackanzahl].sec:=asc2byte (copy (comstri,9,3));
    end;
  until pos ('Ende',comstri)<>0;

 end;


{---------------}
{ Hauptprogramm }
{---------------}
begin
 cd_init_uart;

 cd_get_status;
 writeln ('Tr offen : ',tuer_offen);
 writeln ('CD eingelegt : ',cd_eingelegt);
 writeln ('Typ Audio : ',cd_typ_audio);
 writeln ('CD luft : ',wiedergabe_laeuft);


 writeln ('Info holen');readln;
 cd_get_info;
 for zaehler:=1 to trackanzahl do
  writeln (trackinfo [zaehler].number,' ',trackinfo [zaehler].min,':',trackinfo [zaehler].sec);

 writeln ('ffnen');readln;
 cd_open;

 writeln ('Schliesse');readln;
 cd_close;

 writeln ('Spiele');readln;
 cd_play;

 writeln ('Zeit');readln;
 cd_get_time;
 writeln ('Aktueller Track : ',aktueller_track);
 writeln ('Aktueller Index : ',aktueller_index);
 writeln ('Minuten : ',aktuelle_minute);
 writeln ('Sekunden : ',aktuelle_sekunde);

 writeln ('Skip+');readln;
 cd_skip_forward;

  writeln ('Skip+');readln;
 cd_skip_forward;

 writeln ('Skip-');readln;
 cd_skip_back;

 writeln ('Stop');readln;
 cd_stop;

end.



    'A' : begin { Audio Information }

           cd_info;

           { CD eingelegt, aber kein Audiotrack drauf ? }
           if ((cd.devpar and (1 shl 11))=0) and (cd.hiautr<>cd.loautr)
            then
             begin

              return ('Audio-Tracks : '+byte2asc (cd.loautr)+'..'+byte2asc (cd.hiautr)+#10+#13);
              return ('Laufzeiten : '+#10+#13);
              for i := CD.LoAuTr to CD.HiAuTr do
               with VTOC.Titles[i] do
                return (byte2asc (i)+' '+byte2asc (RunMin)+':'+byte2asc (RunSec)+#10+#13);
             end else return ('Fehler'+#10#13);

            return ('Ende'+#10#13);

          end;





