Program Jukebox; { Erstellt mit Turbo Pascal 6.0 }

uses dos,crt,csio,seriell;

     { Informationen zur CD }
type trkifo             = record
                           number,min,sec : byte;
                          end;

const

        { Motoradressen }
        adress_heber             : byte = $A5;
        adress_teller            : byte = $A0;
        adress_schwenker         : byte = $A2;
        adress_dreher            : byte = $A3;
        adress_greifer           : byte = $A1;

        { Motorbefehle }
        m_goref                  : byte = $01;
        m_stepforward            : byte = $02;
        m_stepback               : byte = $03;
        m_identify               : byte = $04;

        {----------------------------------------------------}

        { Lampenadressen }
        adress_lampe_top_left    : byte = $C0;
        adress_lampe_top_right   : byte = $C1;
        mischer_rot              : byte = $C2;
        mischer_gruen            : byte = $C3;
        mischer_blau             : byte = $C4;

        { Lampenbefehle }
        l_switch                 : byte = $01;
        l_dimmrel                : byte = $03;
        l_dimmabs                : byte = $02;
        l_identify               : byte = $04;

        {----------------------------------------------------}

        { Displayadressen }
        adress_display_big       : byte = $B0;

        { Displaybefehle }
        d_identify               : byte = $04;

        {----------------------------------------------------}

        { Schrittpositionen Teller entsprechend der CD-Nummer }
        tellerposition : array [1..12] of word =
         (0,269,565,835,1135,1425,1675,1990,2262,2525,2825,3085);

        { Schrittposition Greifer entsprechend Position geschlossen }
        greiferposition : word = 8800;

        { Schrittposition Heber entsprechend Position oben }
        heberposition : word = 4800;

        { Schrittpositionen Schwenker entsprechend links, oben, rechts }
        schwenkerposition : array [1..3] of word = (300,280,196);

        { Schrittpositionen Dreher entsprechend einlegen, herausnehmen }
        dreherposition : array [1..2] of word = (40,320);


        {------------ Typen ------------------}

type    disbuf = array [1..4,1..40] of byte;

        {----------- Variablen ---------------}

var     { Vorhandene Hardware }
        heber, schwenker, dreher, Teller, greifer,
        lampe_oben_links, lampe_oben_rechts,
        lampe_mischer_rot,lampe_mischer_gruen,
        lampe_mischer_blau,display_big                  : boolean;

        { Vorhandene Harwaregruppen }
        motoren, lampen, displays, IO                   : boolean;

        { Aktuelle Schrittpositionen }
        schrittpos                                      : array [1..10] of longint;

        { Puffer fr das groe Display }
        display_big_buffer,display_big_buffer_old       : disbuf;

        { Universelles Zeug }
        ch                                              : char;

        { CD-bezogene Variablen }

        { Aktueller Status des Laufwerks }
        cd_eingelegt,tuer_offen                     : Boolean;
        cd_typ_audio                                : boolean;
        wiedergabe_laeuft                           : boolean;

        aktueller_track, aktueller_index            : byte;
        aktuelle_minute, aktuelle_sekunde           : byte;

        trackinfo                                   : array[1..100] of trkifo;
        trackanzahl                                 : byte;


{-----------------------------}
{ Status- und Fehlermeldungen }
{-----------------------------}

{ Alles im ARSCH }
procedure fatal_error (txt : string);
 begin
  writeln (txt);
  writeln (#10#13,'Programm abgebrochen mit Fehlercode 255');
  halt (255);
 end;

{ Meldung ausgeben }
procedure meldung (txt : string);
 begin
  writeln (txt);
 end;

{ Fehler ausgeben }
procedure fehler (txt : string;warning : boolean);
var ch : char;
 begin
  if warning then write ('Warnung : ') else write ('Fehler : ');
  write (txt,'  ');

  if warning then
   begin
    write ('Weitermachen (j/n) ');
    repeat
     ch:=readkey;
    until ch in ['j','n','J','N'];
    if upcase (ch)='N' then
     begin
      writeln (#10#13,'Programm abgebrochen mit Fehlercode 255');
      halt (255);
     end else writeln ('J');

   end else writeln;

 end;

{-----------------}
{ Anzeigeoptionen }
{-----------------}
function asc2byte (txt : string) : byte;
var valerror : integer;
    zahl     : byte;
    puffer   : string;
 begin
  puffer:=txt;
  while (length (puffer)>0) and (pos ('0',puffer)<>0 ) do
   delete (puffer,pos ('0',puffer),1);
  while (length (puffer)>0) and (pos (' ',puffer)<>0 ) do
   delete (puffer,pos (' ',puffer),1);
  val (puffer,zahl,valerror);
  asc2byte:=zahl;

 end;

function byte2asc (hin : byte) : string;
var buf : string;
    puf,divi : byte;

 begin
  buf:='';
  puf:=hin;

  { 100 }
  divi:=puf div 100;
  puf:=puf- (divi*100);
  buf:=buf+chr (divi+48);

  { 10 }
  divi:=puf div 10;
  puf:=puf- (divi*10);
  buf:=buf+chr (divi+48);

  { 1 }
  buf:=buf+chr (puf+48);

  byte2asc:=buf;
 end;


{-----------------------}
{ Reset-Impuls erzeugen }
{-----------------------}
procedure reset_konverter;
var dummy : byte;
    flag  : boolean;

 begin

  { Negative Flanke am Controller erzeugen }
  dropdtr;
  delay (300);
  setdtr;
  delay (300);

  { Puffer leeren, falls noch was im der Rhre schlummert.... }
  repeat
   dummy:=read_byte (100,flag);
  until flag;

  delay (300);

 end;

{---------------------------------------------}
{ Warten auf das Acknowledge der RS485-Slaves }
{---------------------------------------------}
function get_acknowledge (adress,command,time : byte) : boolean;
var ack_adress, ack_command : byte;
    timeout                 : integer;
    flag                    : boolean;
    inbytes                 : array [1..8] of byte;
    incount                 : byte;

 begin

  { Warten auf die zwei Acknowledge-Zeichen Adresse und Kommando }

  incount:=1;
  flag:=false;

  { Zeichen reinholen }
  while (incount<=8)  do
   begin

    if time=0 then
     inbytes [incount]:=read_byte (500,flag) else
    repeat
     inbytes [incount]:=read_byte (500,flag);
    until not flag;

    { write (inbytes [incount],' '); }
    inc (incount);
   end;
   { writeln; }

   write (#10#13,'Bytes : ');
   for incount:=1 to 8 do write (inbytes [incount],' ');

   { Adressen zusammensetzen }
   if (chr (inbytes [1]) in ['A'..'F']) then
    inbytes [1]:=inbytes [1]-55 else
    inbytes [1]:=inbytes [1]-48;
   if (chr (inbytes [2]) in ['A'..'F']) then
    inbytes [2]:=inbytes [2]-55 else
    inbytes [2]:=inbytes [2]-48;
   if (chr (inbytes [5]) in ['A'..'F']) then
    inbytes [5]:=inbytes [5]-55 else
    inbytes [5]:=inbytes [5]-48;
   if (chr (inbytes [6]) in ['A'..'F']) then
    inbytes [6]:=inbytes [6]-55 else
    inbytes [6]:=inbytes [6]-48;

   ack_adress:=inbytes [1]*16+inbytes[2];
   ack_command:=inbytes [5]*16+inbytes[6];

  { Beides richtig ? }
  get_acknowledge:=( (ack_adress=adress) AND (ack_command=command) );

  reset_konverter;

 end;

{-------------------------------------------------------------------}
{ Motorkontrolle                                                    }
{-------------------------------------------------------------------}
{$i motor.inc }

{-------------------------------------------------------------------}
{ Lampenkontrolle                                                   }
{-------------------------------------------------------------------}
{$i lampe.inc }

{---------------------------------------------------------------------}
{ Displaykontrolle                                                    }
{---------------------------------------------------------------------}
{$i display.inc }

{--------------------------------------------------------------------}
{ CD-Steuerungs-Funktionen                                              }
{--------------------------------------------------------------------}
{$i cd_kont.inc }

{-------------------------------------------------------------------}
{ Initialisierungen                                                 }
{-------------------------------------------------------------------}
{$i init.inc }

{--------------------------------------------------------------------}
{ Debug-Funktionen                                                   }
{--------------------------------------------------------------------}
{$i debug.inc }

{--------------------------------------------------------------------}
{ Steuerungs-Funktionen                                              }
{--------------------------------------------------------------------}
{$i steuerng.inc }

{---------------}
{ Hauptprogramm }
{---------------}
begin
 
 startup_init;  { Variablen inititaliseren }
 RS485_init;    { RS485-Hardware klarmachen }
 cd_init_uart;  { Uart fr CD-Kommunikation klarmachen }

 writeln (#10#13,'Hauptmen'#10#13);
 writeln ('1. Debug-Funktionen');
 writeln ('2. bergeordnete Steuerung');

   repeat
    ch:=readkey;
   until ( (ch in ['1'..'2']) or (ch=#27) );

   case ch of
    '1' : begin
           debug_menue;
          end;

    '2' : begin
           steuerung_menue;
          end;

   end; { Von Case }

end.

{--------------------------------------------------------------------}

Initialisierung am Start :

CD im Laufwerk
--------------

Keine CD im Laufwerk
--------------------

- Greifer in Refposition
- Dreher in Refposition
- Schwenker in Refposition
- Heber in Refposition
- Teller in Refposition
